SystemOrganization addCategory: #'JQueryMobile-Samples-Flickr'!

!GRPackage class methodsFor: '*jquerymobile-samples-flickr' stamp: 'NickAger 11/2/2011 16:33'!
jQueryMobileSamplesFlickr
	^ self new
		name: 'JQueryMobile-Samples-Flickr';
		description: 'jQueryMobile Flickr Samples';
		addDependency:  'JQueryMobile-Canvas';
		addDependency:  'JQueryMobile-Email';
		addDependency:  'JQueryMobile-Tools';
		addDependency: 'JQueryMobile-Scripting';
		addDependency: 'JQueryMobile-BookmarkBubble';
		addDependency: 'JQueryMobile-Decorations';
		addDependency: 'Seaside-Component';
		addDependency: 'Seaside-Core';
		url: #seasideUrl;
		yourself
		
	! !

WADecoration subclass: #JQMSampleFlickrHeaderDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQueryMobile-Samples-Flickr'!

!JQMSampleFlickrHeaderDecoration methodsFor: 'rendering' stamp: 'NickAger 11/2/2011 15:09'!
renderContentOn: html
	self renderHeaderOn: html.
	
	super renderContentOn: html! !

!JQMSampleFlickrHeaderDecoration methodsFor: 'rendering' stamp: 'NickAger 11/2/2011 15:10'!
renderHeaderOn: html
	html div
		jqmHeader;
		jqmTheme: 'b';
		with: [
			html heading
				level1;
				with: 'Flickr Show'.
				
			html anchor
				jqmIcon: 'home';
				jqmReverse;
				jqmIconNoText;
				callback: [ self decoratedComponent answer ] ;
				with: 'home' ]! !

!JQMSampleFlickrHeaderDecoration methodsFor: 'rendering' stamp: 'NickAger 11/2/2011 15:45'!
rendererClass
	^ JQMHtmlCanvas! !

WAComponent subclass: #JQMSampleFlickrBase
	instanceVariableNames: 'flickrTag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQueryMobile-Samples-Flickr'!

!JQMSampleFlickrBase methodsFor: 'accessing' stamp: 'NickAger 11/2/2011 14:21'!
flickrTag
	^ flickrTag ifNil: [ flickrTag := 'Smalltalk' ]! !

!JQMSampleFlickrBase methodsFor: 'accessing' stamp: 'NickAger 11/2/2011 14:16'!
flickrTag: anObject
	flickrTag := anObject! !

!JQMSampleFlickrBase methodsFor: 'initialization' stamp: 'NickAger 11/2/2011 15:09'!
initialize
	super initialize.
	
	self addDecoration: JQMIOSHomescreenBookmarkDecorator new.
	self addDecoration: JQMSampleFlickrHeaderDecoration new.! !

!JQMSampleFlickrBase methodsFor: 'rendering' stamp: 'NickAger 11/2/2011 15:44'!
rendererClass
	^ JQMHtmlCanvas! !

JQMSampleFlickrBase subclass: #JQMSampleFlickrHome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQueryMobile-Samples-Flickr'!

!JQMSampleFlickrHome methodsFor: 'initialization' stamp: 'NickAger 11/2/2011 14:51'!
initialize
	super initialize.
	
	self addDecoration: JQMBookmarkBubbleDecoration new! !

!JQMSampleFlickrHome methodsFor: 'rendering' stamp: 'NickAger 11/2/2011 14:25'!
renderContentOn: html
	html div
		jqmContent;
		with: [ 
			self renderFlickrFormOn: html ]! !

!JQMSampleFlickrHome methodsFor: 'rendering' stamp: 'NickAger 11/2/2011 14:26'!
renderFlickrFormOn: html
	html form: [
		html paragraph: 'Welcome to flickr slideshow. Please enter a tag you''d like to search for on flickr:'.
		
		html textInput
			on: #flickrTag of: self.
			
		html submitButton
			callback: [ self show: (JQMSampleFlickrShow flickrTag: self flickrTag)];
			with: 'Slide Show' ]! !

JQMSampleFlickrBase subclass: #JQMSampleFlickrShow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQueryMobile-Samples-Flickr'!

!JQMSampleFlickrShow class methodsFor: 'instance creation' stamp: 'NickAger 11/2/2011 14:17'!
flickrTag: flickrTag
	^ self new
		flickrTag: flickrTag ! !

!JQMSampleFlickrShow methodsFor: 'rendering' stamp: 'NickAger 11/2/2011 14:44'!
renderButtonsOn: html
	html button
		jqmInline;
		onClick: 'showImage(currentImageIndex - 1)';
		with: 'previous'.

	html button
		jqmInline;
		onClick: 'showImage(currentImageIndex + 1)';
		with: 'next'.! !

!JQMSampleFlickrShow methodsFor: 'rendering' stamp: 'NickAger 11/2/2011 15:10'!
renderContentOn: html
	html div
		jqmContent;
		with: [
			self renderJSOn: html.
			self renderButtonsOn: html.
			self renderImagesOn: html.
			self renderTagOn: html ].
		
! !

!JQMSampleFlickrShow methodsFor: 'rendering' stamp: 'NickAger 11/2/2011 14:45'!
renderImagesOn: html
	html div
		id: #images;
		onSwipeLeft: 'showImage(currentImageIndex - 1)';
		onSwipeRight: 'showImage(currentImageIndex + 1)'.

		! !

!JQMSampleFlickrShow methodsFor: 'rendering' stamp: 'NickAger 11/2/2011 15:42'!
renderJSOn: html
	html script: '
	var currentImageIndex = 0;
	var showImage = function(index) {
		var maxImageIndex = $("#images").children().length - 1;
		index = index < 0 ? maxImageIndex : index ;
		index = index >  maxImageIndex ? 0 : index ;
		
		var currentImage = $($("#images").children()[currentImageIndex]);
		var newImage = $($("#images").children()[index]);
		
		currentImage.hide();
		newImage.show();
		currentImageIndex = index;
	}'.
		
	html document addLoadScript: 
		(html jQuery getJson
 		        url: 'http://api.flickr.com/services/feeds/photos_public.gne?tags=', self flickrTag, '&format=json&jsoncallback=?';
   		      onSuccess: '$.each(arguments[0].items, function(index, each) {
           		 $("<img/>").attr("src", each.media.m).attr("title", each.title).appendTo("#images").hide()});showImage(0)').! !

!JQMSampleFlickrShow methodsFor: 'rendering' stamp: 'NickAger 11/2/2011 14:48'!
renderTagOn: html
	html paragraph: [
		html text: 'flickr tag: "'; text: self flickrTag; text: '"'
		]! !
